/*
 * Drive MAX5159 via SPI
 * (c) 2012 Matt Evans
 * Licenced under GPLv2
 */

#include "dac.h"

static void dac_write16(uint16_t w)
{
	PORTB &= ~NCS;
	SPDR = (w >> 8) & 0xff;
	loop_until_bit_is_set(SPSR, SPIF);
	SPDR = (w & 0xff);
	loop_until_bit_is_set(SPSR, SPIF);
	PORTB |= NCS;
}

void dac_init(void)
{
	/* SPI init */
        DDRB |= B(SPI_MOSI) | B(SPI_SCLK) | B(PB2);
        DDRB &= ~B(SPI_MISO);
	DDRB |= NCS;
	PORTB |= NCS | B(PB2);		/* Disable */
	SPSR = B(SPI2X);
        /* Enable SPI, Master, set clock rate fck/2 -- 4MHz */
        SPCR = B(SPE) | B(MSTR);

	dac_write16(0x6000); /* Both dacs 0 */
}

void dac_write(uint16_t a, uint16_t b)
{
	dac_write16(0x2000 | ((a << 3) & 0x1ff8));
	dac_write16(0xc000 | ((b << 3) & 0x1ff8));
}
