/*
 * General hardware defs for scope3d
 * (c) 2012 Matt Evans
 * Licenced under GPLv2
 */

#ifndef HW_H
#define HW_H

#include <inttypes.h>

#define F_CPU 20000000UL

#include <avr/io.h>

#define B(x) (1<<(x))

#define BAUDRATE 38400UL

#define UBRR ((F_CPU / (16 * BAUDRATE)) - 1)

/* LED is on PB0 */
#define LEDG (1<<PB0)

#define WAIT    do { asm("nop\n nop\n nop\n"); } while(0);

#define LEDG_ON  do { PORTB |= LEDG; }  while(0)
#define LEDG_OFF do { PORTB &= ~LEDG; } while(0)
#define LEDG_TOGGLE  do { PORTB ^= LEDG; }  while(0)

void delay_cs(uint8_t s);


#endif
