#!/usr/bin/perl
#
# Make a number of lookup tables:
# 	sine table
#       divide table

use Math::Trig;

$res = 15;

$pi = 3.141592654;

sub print_label
{
    my $l = shift;
    print ".globl $l\n$l:\n_$l:\n";
}

my $sinsteps = 512;
my $divsteps = 1024;

print_label("sintab");
print ".short ";
    
for ($x = 0; $x < $sinsteps; $x++)
{
    # The sine table goes from 0-90 degrees and is reflected
    printf("0x%04x", (((1<<$res)-1) * sin( 0.5 * $pi * $x / $sinsteps )) & ((1<<($res+1))-1));

    print ", " unless ($x == ($sinsteps-1));
}
print "\n.align\n";

print_label("divtab_a");
print ".short ";
# Divide:  0:16 fixed point.  DOES NOT include /0 or /1.
# First table = 16bit values for 2-256
# Second = byte values (as they are all < 256!)
for ($x = 2; $x <= 256; $x++) {
    printf("0x%04x", (1<<16)/$x );

    print ", " unless ($x == 256); 
}
print "\n.align\n";

print_label("divtab_b");
print ".byte ";
for ($x = 257; $x < 1024; $x++) {
    printf("0x%02x", (1<<16)/$x );

    print ", " unless ($x == 1023);
}
print "\n.align\n";
