/* Serial IO
 *
 * (c) 2012 Matt Evans
 * Licenced under GPLv2
 */

#ifndef SERIO_H
#define SERIO_H

#include "hw.h"
#include <inttypes.h>
#include <avr/io.h>
#include <avr/pgmspace.h>

#define PS(x) printstr_p(PSTR(x))

void putchr(char c);
char getchr(void);
uint8_t rx_data_ready(void);

void pnewl();

void printstr_p(const char *s);

void phex8(uint8_t n);
void phex16(uint16_t n);
void phex32(uint32_t n);

uint8_t gethex4(void);

void serio_init(void);

#endif
